diff --git a/web/pgadmin/browser/register_browser_preferences.py b/web/pgadmin/browser/register_browser_preferences.py
index 169f506ba..4f7d376cf 100644
--- a/web/pgadmin/browser/register_browser_preferences.py
+++ b/web/pgadmin/browser/register_browser_preferences.py
@@ -130,6 +130,12 @@ def register_browser_preferences(self):
         )
     )
 
+    self.table_row_count_threshold = self.preference.register(
+        'processes', 'process_retain_days',
+        gettext("Process details/logs retain days"), 'integer', 5,
+        category_label=gettext('Processes')
+    )
+
     fields = [
         {'name': 'key', 'type': 'keyCode', 'label': gettext('Key')},
         {'name': 'shift', 'type': 'checkbox', 'label': gettext('Shift')},
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/views/__init__.py b/web/pgadmin/browser/server_groups/servers/databases/schemas/views/__init__.py
index 210feab16..f9183d997 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/schemas/views/__init__.py
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/views/__init__.py
@@ -174,7 +174,7 @@ class Message(IProcessDesc):
         return gettext("Refresh Materialized View")
 
     def details(self, cmd, args):
-        res = gettext("Refresh Materialized View ({0})")
+        msg = gettext("Refresh Materialized View ({0})")
         opts = []
         if not self.data['is_with_data']:
             opts.append(gettext("WITH NO DATA"))
@@ -184,17 +184,12 @@ class Message(IProcessDesc):
         if self.data['is_concurrent']:
             opts.append(gettext("CONCURRENTLY"))
 
-        res = res.format(', '.join(str(x) for x in opts))
+        msg = msg.format(', '.join(str(x) for x in opts))
 
-        res = '<div>' + html.safe_str(res)
-
-        res += '</div><div class="py-1">'
-        res += gettext("Running Query:")
-        res += '<div class="pg-bg-cmd enable-selection p-1">'
-        res += html.safe_str(self.query)
-        res += '</div></div>'
-
-        return res
+        return {
+            "message": msg,
+            "query": self.query
+        }
 
 
 class MViewModule(ViewModule):
@@ -2276,6 +2271,7 @@ class MViewNode(ViewNode, VacuumSettings):
             return make_json_response(
                 data={
                     'job_id': jid,
+                    'desc': p.desc.message,
                     'status': True,
                     'info': gettext(
                         'Materialized view refresh job created.')
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/views/static/js/mview.js b/web/pgadmin/browser/server_groups/servers/databases/schemas/views/static/js/mview.js
index b9a86008d..d91e37ea4 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/schemas/views/static/js/mview.js
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/views/static/js/mview.js
@@ -205,7 +205,7 @@ define('pgadmin.node.mview', [
               if (refreshed_res.data && refreshed_res.data.status) {
               //Do nothing as we are creating the job and exiting from the main dialog
                 Notify.success(refreshed_res.data.info);
-                pgBrowser.Events.trigger('pgadmin-bgprocess:created');
+                pgBrowser.BgProcessManager.startProcess(refreshed_res.data.job_id, refreshed_res.data.desc);
               } else {
                 Notify.alert(
                   gettext('Failed to create materialized view refresh job.'),
diff --git a/web/pgadmin/browser/static/js/browser.js b/web/pgadmin/browser/static/js/browser.js
index 53d58c253..3fa870332 100644
--- a/web/pgadmin/browser/static/js/browser.js
+++ b/web/pgadmin/browser/static/js/browser.js
@@ -266,6 +266,19 @@ define('pgadmin.browser', [
         content: '<div class="negative-space p-2"><div role="status" class="pg-panel-message pg-panel-depends-message">' + select_object_msg + '</div><div class="pg-panel-dependents-container d-none"></div></div>',
         events: panelEvents,
       }),
+      // Background processes
+      'processes': new pgAdmin.Browser.Panel({
+        name: 'processes',
+        title: gettext('Processes'),
+        icon: '',
+        width: 500,
+        isCloseable: true,
+        isPrivate: false,
+        limit: 1,
+        canHide: true,
+        content: '<div class="negative-space p-2"><div class="pg-panel-processes-container d-none"></div></div>',
+        events: panelEvents,
+      }),
     },
     // We also support showing dashboards, HTML file, external URL
     frames: {},
diff --git a/web/pgadmin/browser/static/js/layout.js b/web/pgadmin/browser/static/js/layout.js
index 689028f3d..fff14e7ba 100644
--- a/web/pgadmin/browser/static/js/layout.js
+++ b/web/pgadmin/browser/static/js/layout.js
@@ -42,6 +42,8 @@ _.extend(pgBrowser, {
       'dependencies', wcDocker.DOCK.STACKED, dashboardPanel);
     docker.addPanel(
       'dependents', wcDocker.DOCK.STACKED, dashboardPanel);
+    docker.addPanel(
+      'processes', wcDocker.DOCK.STACKED, dashboardPanel);
   },
 
   save_current_layout: function(layout_id, docker) {
diff --git a/web/pgadmin/browser/static/js/panel.js b/web/pgadmin/browser/static/js/panel.js
index 8f1d1b7ab..a2cd057ba 100644
--- a/web/pgadmin/browser/static/js/panel.js
+++ b/web/pgadmin/browser/static/js/panel.js
@@ -122,7 +122,7 @@ define(
                 that.resizedContainer.apply(myPanel);
               }
 
-              if (myPanel._type == 'dashboard') {
+              if (myPanel._type == 'dashboard' || myPanel._type == 'processes') {
                 getPanelView(
                   pgBrowser.tree,
                   $container[0],
diff --git a/web/pgadmin/browser/static/js/panel_view.jsx b/web/pgadmin/browser/static/js/panel_view.jsx
index 8302af60a..c1274b840 100644
--- a/web/pgadmin/browser/static/js/panel_view.jsx
+++ b/web/pgadmin/browser/static/js/panel_view.jsx
@@ -17,6 +17,7 @@ import SQL from '../../../misc/sql/static/js/SQL';
 import Dashboard from '../../../dashboard/static/js/Dashboard';
 import _ from 'lodash';
 import { CollectionNodeView } from '../../../misc/properties/CollectionNodeProperties';
+import Processes from '../../../misc/bgprocess/static/js/Processes';
 
 
 /* The entry point for rendering React based view in properties, called in node.js */
@@ -131,6 +132,14 @@ export function getPanelView(
       container
     );
   }
+  if (panelType == 'processes') {
+    ReactDOM.render(
+      <Theme>
+        <Processes />
+      </Theme>,
+      container
+    );
+  }
 }
 
 /* When switching from normal node to collection node, clean up the React mounted DOM */
diff --git a/web/pgadmin/dashboard/static/js/Dashboard.jsx b/web/pgadmin/dashboard/static/js/Dashboard.jsx
index 31f6cd0e0..c8f5b0f04 100644
--- a/web/pgadmin/dashboard/static/js/Dashboard.jsx
+++ b/web/pgadmin/dashboard/static/js/Dashboard.jsx
@@ -143,7 +143,7 @@ export default function Dashboard({
     {
       accessor: 'name',
       Header: gettext('Name'),
-      sortble: true,
+      sortable: true,
       resizable: true,
       disableGlobalFilter: false,
       minWidth: 50,
@@ -153,7 +153,7 @@ export default function Dashboard({
     {
       accessor: 'category',
       Header: gettext('Category'),
-      sortble: true,
+      sortable: true,
       resizable: true,
       disableGlobalFilter: false,
       minWidth: 50,
@@ -161,7 +161,7 @@ export default function Dashboard({
     {
       accessor: 'setting',
       Header: gettext('Value'),
-      sortble: true,
+      sortable: true,
       resizable: true,
       disableGlobalFilter: false,
       minWidth: 50,
@@ -170,7 +170,7 @@ export default function Dashboard({
     {
       accessor: 'unit',
       Header: gettext('Unit'),
-      sortble: true,
+      sortable: true,
       resizable: true,
       disableGlobalFilter: false,
       minWidth: 26,
@@ -179,7 +179,7 @@ export default function Dashboard({
     {
       accessor: 'short_desc',
       Header: gettext('Description'),
-      sortble: true,
+      sortable: true,
       resizable: true,
       disableGlobalFilter: false,
     },
@@ -189,7 +189,7 @@ export default function Dashboard({
     {
       accessor: 'terminate_query',
       Header: () => null,
-      sortble: true,
+      sortable: true,
       resizable: false,
       disableGlobalFilter: false,
       width: 35,
@@ -261,7 +261,7 @@ export default function Dashboard({
     {
       accessor: 'cancel_Query',
       Header: () => null,
-      sortble: true,
+      sortable: true,
       resizable: false,
       disableGlobalFilter: false,
       width: 35,
@@ -330,7 +330,7 @@ export default function Dashboard({
     {
       accessor: 'view_active_query',
       Header: () => null,
-      sortble: true,
+      sortable: true,
       resizable: false,
       disableGlobalFilter: false,
       width: 35,
@@ -374,7 +374,7 @@ export default function Dashboard({
     {
       accessor: 'pid',
       Header: gettext('PID'),
-      sortble: true,
+      sortable: true,
       resizable: true,
       disableGlobalFilter: false,
       minWidth: 26,
@@ -383,7 +383,7 @@ export default function Dashboard({
     {
       accessor: 'datname',
       Header: gettext('Database'),
-      sortble: true,
+      sortable: true,
       resizable: true,
       disableGlobalFilter: false,
       minWidth: 26,
@@ -393,7 +393,7 @@ export default function Dashboard({
     {
       accessor: 'usename',
       Header: gettext('User'),
-      sortble: true,
+      sortable: true,
       resizable: true,
       disableGlobalFilter: false,
       minWidth: 26,
@@ -402,7 +402,7 @@ export default function Dashboard({
     {
       accessor: 'application_name',
       Header: gettext('Application'),
-      sortble: true,
+      sortable: true,
       resizable: true,
       disableGlobalFilter: false,
       minWidth: 26,
@@ -410,7 +410,7 @@ export default function Dashboard({
     {
       accessor: 'client_addr',
       Header: gettext('Client'),
-      sortble: true,
+      sortable: true,
       resizable: true,
       disableGlobalFilter: false,
       minWidth: 26,
@@ -418,7 +418,7 @@ export default function Dashboard({
     {
       accessor: 'backend_start',
       Header: gettext('Backend start'),
-      sortble: true,
+      sortable: true,
       resizable: true,
       disableGlobalFilter: false,
       minWidth: 100,
@@ -426,7 +426,7 @@ export default function Dashboard({
     {
       accessor: 'xact_start',
       Header: gettext('Transaction start'),
-      sortble: true,
+      sortable: true,
       resizable: true,
       disableGlobalFilter: false,
       minWidth: 26,
@@ -434,7 +434,7 @@ export default function Dashboard({
     {
       accessor: 'state',
       Header: gettext('State'),
-      sortble: true,
+      sortable: true,
       resizable: true,
       disableGlobalFilter: false,
       minWidth: 26,
@@ -444,7 +444,7 @@ export default function Dashboard({
     {
       accessor: 'waiting',
       Header: gettext('Waiting'),
-      sortble: true,
+      sortable: true,
       resizable: true,
       disableGlobalFilter: false,
       isVisible: treeNodeInfo?.server?.version < 90600
@@ -452,14 +452,14 @@ export default function Dashboard({
     {
       accessor: 'wait_event',
       Header: gettext('Wait event'),
-      sortble: true,
+      sortable: true,
       resizable: true,
       disableGlobalFilter: false,
     },
     {
       accessor: 'blocking_pids',
       Header: gettext('Blocking PIDs'),
-      sortble: true,
+      sortable: true,
       resizable: true,
       disableGlobalFilter: false,
     },
@@ -469,7 +469,7 @@ export default function Dashboard({
     {
       accessor: 'pid',
       Header: gettext('PID'),
-      sortble: true,
+      sortable: true,
       resizable: true,
       disableGlobalFilter: false,
       minWidth: 26,
@@ -478,7 +478,7 @@ export default function Dashboard({
     {
       accessor: 'datname',
       Header: gettext('Database'),
-      sortble: true,
+      sortable: true,
       resizable: true,
       disableGlobalFilter: false,
       minWidth: 26,
@@ -488,7 +488,7 @@ export default function Dashboard({
     {
       accessor: 'locktype',
       Header: gettext('Lock type'),
-      sortble: true,
+      sortable: true,
       resizable: true,
       disableGlobalFilter: false,
       minWidth: 26,
@@ -497,14 +497,14 @@ export default function Dashboard({
     {
       accessor: 'relation',
       Header: gettext('Target relation'),
-      sortble: true,
+      sortable: true,
       resizable: true,
       disableGlobalFilter: false,
     },
     {
       accessor: 'page',
       Header: gettext('Page'),
-      sortble: true,
+      sortable: true,
       resizable: true,
       disableGlobalFilter: false,
       minWidth: 26,
@@ -513,7 +513,7 @@ export default function Dashboard({
     {
       accessor: 'tuple',
       Header: gettext('Tuple'),
-      sortble: true,
+      sortable: true,
       resizable: true,
       disableGlobalFilter: false,
       minWidth: 26,
@@ -521,7 +521,7 @@ export default function Dashboard({
     {
       accessor: 'virtualxid',
       Header: gettext('vXID (target)'),
-      sortble: true,
+      sortable: true,
       resizable: true,
       disableGlobalFilter: false,
       minWidth: 50,
@@ -530,7 +530,7 @@ export default function Dashboard({
     {
       accessor: 'transactionid',
       Header: gettext('XID (target)'),
-      sortble: true,
+      sortable: true,
       resizable: true,
       disableGlobalFilter: false,
       minWidth: 50,
@@ -539,7 +539,7 @@ export default function Dashboard({
     {
       accessor: 'classid',
       Header: gettext('Class'),
-      sortble: true,
+      sortable: true,
       resizable: true,
       disableGlobalFilter: false,
       minWidth: 26,
@@ -548,7 +548,7 @@ export default function Dashboard({
     {
       accessor: 'objid',
       Header: gettext('Object ID'),
-      sortble: true,
+      sortable: true,
       resizable: true,
       disableGlobalFilter: false,
       minWidth: 50,
@@ -558,7 +558,7 @@ export default function Dashboard({
     {
       accessor: 'virtualtransaction',
       Header: gettext('vXID (owner)'),
-      sortble: true,
+      sortable: true,
       resizable: true,
       disableGlobalFilter: false,
       minWidth: 50,
@@ -566,7 +566,7 @@ export default function Dashboard({
     {
       accessor: 'mode',
       Header: gettext('Mode'),
-      sortble: true,
+      sortable: true,
       resizable: true,
       disableGlobalFilter: false,
     },
@@ -574,7 +574,7 @@ export default function Dashboard({
       id: 'granted',
       accessor: 'granted',
       Header: gettext('Granted?'),
-      sortble: true,
+      sortable: true,
       resizable: true,
       disableGlobalFilter: false,
       minWidth: 30,
@@ -587,14 +587,14 @@ export default function Dashboard({
     {
       accessor: 'git',
       Header: gettext('Name'),
-      sortble: true,
+      sortable: true,
       resizable: true,
       disableGlobalFilter: false,
     },
     {
       accessor: 'datname',
       Header: gettext('Database'),
-      sortble: true,
+      sortable: true,
       resizable: true,
       disableGlobalFilter: false,
       minWidth: 26,
@@ -604,21 +604,21 @@ export default function Dashboard({
     {
       accessor: 'Owner',
       Header: gettext('Owner'),
-      sortble: true,
+      sortable: true,
       resizable: true,
       disableGlobalFilter: false,
     },
     {
       accessor: 'transaction',
       Header: gettext('XID'),
-      sortble: true,
+      sortable: true,
       resizable: true,
       disableGlobalFilter: false,
     },
     {
       accessor: 'prepared',
       Header: gettext('Prepared at'),
-      sortble: true,
+      sortable: true,
       resizable: true,
       disableGlobalFilter: false,
     },
diff --git a/web/pgadmin/misc/bgprocess/processes.py b/web/pgadmin/misc/bgprocess/processes.py
index 2510cc29d..abaad3fd4 100644
--- a/web/pgadmin/misc/bgprocess/processes.py
+++ b/web/pgadmin/misc/bgprocess/processes.py
@@ -16,17 +16,19 @@ import os
 import sys
 import psutil
 from abc import ABCMeta, abstractproperty, abstractmethod
-from datetime import datetime
+from datetime import datetime, timedelta
 from pickle import dumps, loads
 from subprocess import Popen, PIPE
 import logging
 import json
+import shutil
 
 from pgadmin.utils import u_encode, file_quote, fs_encoding, \
     get_complete_file_path, get_storage_directory, IS_WIN
 from pgadmin.browser.server_groups.servers.utils import does_server_exists
 from pgadmin.utils.constants import KERBEROS
 from pgadmin.utils.locker import ConnectionLocker
+from pgadmin.utils.preferences import Preferences
 
 import pytz
 from dateutil import parser
@@ -463,8 +465,9 @@ class BatchProcess(object):
         idx = 0
         c = re.compile(r"(\d+),(.*$)")
 
+        # If file is not present then
         if not os.path.isfile(logfile):
-            return 0, False
+            return 0, True
 
         with open(logfile, 'rb') as f:
             eofs = os.fstat(f.fileno()).st_size
@@ -695,8 +698,22 @@ class BatchProcess(object):
         processes = Process.query.filter_by(user_id=current_user.id)
         changed = False
 
+        browser_preference = Preferences.module('browser')
+        expiry_add = timedelta(
+            browser_preference.preference('process_retain_days').get() or 1
+        )
+
         res = []
-        for p in processes:
+        for p in [*processes]:
+            if p.start_time is not None:
+                process_expiration_time = \
+                    parser.parse(p.start_time) + expiry_add
+                if datetime.now(process_expiration_time.tzinfo) >= \
+                        process_expiration_time:
+                    shutil.rmtree(p.logdir, True)
+                    db.session.delete(p)
+                    changed = True
+
             status, updated = BatchProcess.update_process_info(p)
             if not status:
                 continue
@@ -732,6 +749,7 @@ class BatchProcess(object):
                 'acknowledge': p.acknowledge,
                 'execution_time': execution_time,
                 'process_state': p.process_state,
+                'utility_pid': p.utility_pid,
                 'current_storage_dir': current_storage_dir,
             })
 
@@ -834,13 +852,15 @@ class BatchProcess(object):
             process.terminate()
             # Update the process state to "Terminated"
             p.process_state = PROCESS_TERMINATED
-            db.session.commit()
+        except psutil.NoSuchProcess:
+            p.process_state = PROCESS_TERMINATED
         except psutil.Error as e:
             current_app.logger.warning(
                 _("Unable to kill the background process '{0}'").format(
                     p.utility_pid)
             )
             current_app.logger.exception(e)
+        db.session.commit()
 
     @staticmethod
     def update_server_id(_pid, _sid):
diff --git a/web/pgadmin/misc/bgprocess/static/js/BgProcessManager.js b/web/pgadmin/misc/bgprocess/static/js/BgProcessManager.js
new file mode 100644
index 000000000..88a810b40
--- /dev/null
+++ b/web/pgadmin/misc/bgprocess/static/js/BgProcessManager.js
@@ -0,0 +1,191 @@
+/////////////////////////////////////////////////////////////
+//
+// pgAdmin 4 - PostgreSQL Tools
+//
+// Copyright (C) 2013 - 2022, The pgAdmin Development Team
+// This software is released under the PostgreSQL Licence
+//
+//////////////////////////////////////////////////////////////
+
+import getApiInstance, { parseApiError } from '../../../../static/js/api_instance';
+import url_for from 'sources/url_for';
+import Notifier from '../../../../static/js/helpers/Notifier';
+import EventBus from '../../../../static/js/helpers/EventBus';
+import * as BgProcessNotify from './BgProcessNotify';
+import showDetails from './showDetails';
+
+const WORKER_INTERVAL = 1000;
+
+export const BgProcessManagerEvents = {
+  LIST_UPDATED: 'LIST_UPDATED',
+};
+
+export const BgProcessManagerProcessState = {
+  PROCESS_NOT_STARTED: 0,
+  PROCESS_STARTED: 1,
+  PROCESS_FINISHED: 2,
+  PROCESS_TERMINATED: 3,
+  /* Supported by front end only */
+  PROCESS_TERMINATING: 10,
+  PROCESS_FAILED: 11,
+};
+
+
+export default class BgProcessManager {
+  static instance;
+
+  static getInstance(...args) {
+    if (!BgProcessManager.instance) {
+      BgProcessManager.instance = new BgProcessManager(...args);
+    }
+    return BgProcessManager.instance;
+  }
+
+  constructor(pgBrowser) {
+    this.api = getApiInstance();
+    this.pgBrowser = pgBrowser;
+    this._procList = [];
+    this._workerId = null;
+    this._pendingJobId = [];
+    this._eventManager = new EventBus();
+  }
+
+  init() {
+    if (this.initialized) {
+      return;
+    }
+    this.initialized = true;
+    this.startWorker();
+  }
+
+  get procList() {
+    return this._procList;
+  }
+
+  set procList(val) {
+    throw new Error('Property processList is readonly.', val);
+  }
+
+  startWorker() {
+    let self = this;
+    self.syncProcesses();
+    this._workerId = setInterval(()=>{
+      if(self._pendingJobId.length > 0) {
+        self.syncProcesses();
+      }
+    }, WORKER_INTERVAL);
+  }
+
+  evaluateProcessState(p) {
+    let retState = p.process_state;
+    if((p.etime || p.exit_code !=null) && p.process_state == BgProcessManagerProcessState.PROCESS_STARTED) {
+      retState =  BgProcessManagerProcessState.PROCESS_FINISHED;
+    }
+    if(retState == BgProcessManagerProcessState.PROCESS_FINISHED && p.exit_code != 0) {
+      retState = BgProcessManagerProcessState.PROCESS_FAILED;
+    }
+    return retState;
+  }
+
+  syncProcesses() {
+    this.api.get(url_for('bgprocess.list'))
+      .then((res)=>{
+        this._procList = res.data?.map((p)=>{
+          return {
+            ...p,
+            process_state: this.evaluateProcessState(p),
+          };
+        });
+        this._eventManager.fireEvent(BgProcessManagerEvents.LIST_UPDATED);
+        this.checkPending();
+      })
+      .catch((err)=>{
+        console.error(err);
+      });
+  }
+
+  checkPending() {
+    const completedProcIds = this.procList.filter((p)=>{
+      if(![
+        BgProcessManagerProcessState.PROCESS_NOT_STARTED,
+        BgProcessManagerProcessState.PROCESS_STARTED,
+        BgProcessManagerProcessState.PROCESS_TERMINATING].includes(p.process_state)) {
+        return true;
+      }
+    }).map((p)=>p.id);
+    this._pendingJobId = this._pendingJobId.filter((id)=>{
+      if(completedProcIds.includes(id)) {
+        let p = this.procList.find((p)=>p.id==id);
+        BgProcessNotify.processCompleted(p?.desc, p?.process_state, this.openProcessesPanel.bind(this));
+        return false;
+      }
+      return true;
+    });
+  }
+
+  startProcess(jobId, desc) {
+    if(jobId) {
+      this._pendingJobId.push(jobId);
+      BgProcessNotify.processStarted(desc, this.openProcessesPanel.bind(this));
+    }
+  }
+
+  stopProcess(jobId) {
+    this.procList.find((p)=>p.id == jobId).process_state = BgProcessManagerProcessState.PROCESS_TERMINATING;
+    this._eventManager.fireEvent(BgProcessManagerEvents.LIST_UPDATED);
+    this.api.put(url_for('bgprocess.stop_process', {
+      pid: jobId,
+    }))
+      .then(()=>{
+        this.procList.find((p)=>p.id == jobId).process_state = BgProcessManagerProcessState.PROCESS_TERMINATED;
+        this._eventManager.fireEvent(BgProcessManagerEvents.LIST_UPDATED);
+      })
+      .catch((err)=>{
+        Notifier.error(parseApiError(err));
+      });
+  }
+
+  acknowledge(jobId) {
+    const removeJob = ()=>{
+      this._procList = this.procList.filter((p)=>p.id!=jobId);
+      this._eventManager.fireEvent(BgProcessManagerEvents.LIST_UPDATED);
+    };
+    this.api.put(url_for('bgprocess.acknowledge', {
+      pid: jobId,
+    }))
+      .then(()=>{
+        removeJob();
+      })
+      .catch((err)=>{
+        if(err.response?.status == 410) {
+        /* Object not available */
+          removeJob();
+        } else {
+          Notifier.error(parseApiError(err));
+        }
+      });
+  }
+
+  viewJobDetails(jobId) {
+    showDetails(this.procList.find((p)=>p.id==jobId));
+  }
+
+  openProcessesPanel() {
+    let processPanel = this.pgBrowser.docker.findPanels('processes');
+    if(processPanel.length > 0) {
+      processPanel = processPanel[0];
+    } else {
+      let propertiesPanel = this.pgBrowser.docker.findPanels('properties');
+      processPanel = this.pgBrowser.docker.addPanel('processes', window.wcDocker.DOCK.STACKED, propertiesPanel[0]);
+    }
+    processPanel.focus();
+  }
+
+  registerListener(event, callback) {
+    this._eventManager.registerListener(event, callback);
+  }
+
+  deregisterListener(event, callback) {
+    this._eventManager.deregisterListener(event, callback);
+  }
+}
diff --git a/web/pgadmin/misc/bgprocess/static/js/BgProcessNotify.jsx b/web/pgadmin/misc/bgprocess/static/js/BgProcessNotify.jsx
new file mode 100644
index 000000000..1efb14119
--- /dev/null
+++ b/web/pgadmin/misc/bgprocess/static/js/BgProcessNotify.jsx
@@ -0,0 +1,97 @@
+import { Box, makeStyles } from '@material-ui/core';
+import React from 'react';
+import Notifier from '../../../../static/js/helpers/Notifier';
+import CloseIcon from '@material-ui/icons/CloseRounded';
+import { DefaultButton, PgIconButton } from '../../../../static/js/components/Buttons';
+import clsx from 'clsx';
+import DescriptionOutlinedIcon from '@material-ui/icons/DescriptionOutlined';
+import { BgProcessManagerProcessState } from './BgProcessManager';
+import PropTypes from 'prop-types';
+import gettext from 'sources/gettext';
+
+
+const useStyles = makeStyles((theme)=>({
+  container: {
+    borderRadius: theme.shape.borderRadius,
+    padding: '0.25rem 1rem 1rem',
+    minWidth: '325px',
+    ...theme.mixins.panelBorder.all,
+  },
+  containerHeader: {
+    height: '32px',
+    display: 'flex',
+    justifyContent: 'space-between',
+    fontWeight: 'bold',
+    alignItems: 'center',
+    borderTopLeftRadius: 'inherit',
+    borderTopRightRadius: 'inherit',
+  },
+  containerBody: {
+    marginTop: '1rem',
+  },
+  containerSuccess: {
+    borderColor: theme.palette.success.main,
+    backgroundColor: theme.palette.success.light,
+  },
+  iconSuccess: {
+    color: theme.palette.success.main,
+  },
+  containerError: {
+    borderColor: theme.palette.error.main,
+    backgroundColor: theme.palette.error.light,
+  },
+  iconError: {
+    color: theme.palette.error.main,
+  },
+}));
+
+function ProcessNotifyMessage({title, desc, onClose, onViewProcess, success=true}) {
+  const classes = useStyles();
+  return (
+    <Box className={clsx(classes.container, (success ? classes.containerSuccess : classes.containerError))}>
+      <Box display="flex" justifyContent="space-between" className={classes.containerHeader}>
+        <Box marginRight={'1rem'}>{title}</Box>
+        <PgIconButton size="xs" noBorder icon={<CloseIcon />} onClick={onClose} title={'Close'} className={success ? classes.iconSuccess : classes.iconError} />
+      </Box>
+      <Box className={classes.containerBody}>
+        <Box>{desc}</Box>
+        <Box marginTop={'1rem'} display="flex">
+          <DefaultButton startIcon={<DescriptionOutlinedIcon />} onClick={onViewProcess}>View Processes</DefaultButton>
+        </Box>
+      </Box>
+    </Box>
+  );
+}
+ProcessNotifyMessage.propTypes = {
+  title: PropTypes.string.isRequired,
+  desc: PropTypes.string.isRequired,
+  onClose: PropTypes.func,
+  onViewProcess: PropTypes.func,
+  success: PropTypes.bool,
+};
+
+
+export function processStarted(desc, onViewProcess) {
+  Notifier.notify(
+    <ProcessNotifyMessage title={gettext('Process started')} desc={desc} onViewProcess={onViewProcess}/>,
+    null
+  );
+}
+
+export function processCompleted(desc, process_state, onViewProcess) {
+  let title = gettext('Process completed');
+  let success = true;
+  if(process_state == BgProcessManagerProcessState.PROCESS_TERMINATED) {
+    title = gettext('Process terminated');
+    success = false;
+  } else if(process_state == BgProcessManagerProcessState.PROCESS_FAILED) {
+    title = gettext('Process failed');
+    success = false;
+  }
+
+  Notifier.notify(
+    <ProcessNotifyMessage title={title} desc={desc} onViewProcess={onViewProcess} success={success}/>,
+    null
+  );
+}
+
